// Checking connectivity
#include <stdio.h>

class graph
{
  int n;
  int ** g;

public:

  graph(char * c)
  {
    int i, j;

    n = *c-63;
    c++;

    g = new int * [n];
    for (i = 0 ; i < n ; i++)
      g[i] = new int [n];

    int bit = 5;
    int number = *c-63;
    c++;

    for (i = 1 ; i < n ; i++)
      {
	for (j = 0 ; j < i ; j++)
	  {
	    if (bit == -1)
	      {
		bit = 5;
		number = *c-63;
		c++;
	      }

	    g[j][i] = g[i][j] = (number >> bit) & 1;
	    bit--;
	  }
      }
  }

  ~graph()
  {
    for (int i = 0 ; i < n ; i++)
      delete [] g[i];

    delete [] g;
  }

  void print_graph()
  {
    printf("%c", n+63);

    int bit = 0;
    int number = 0;

    int i, j;
    for (i = 1 ; i < n ; i++)
      {
	for (j = 0 ; j < i ; j++)
	  {
	    bit++;
	    number <<= 1;
	    if (g[i][j] == 1)
	      number++;

	    if (bit == 6)
	      {
		printf("%c", number+63);
		bit = number = 0;
	      }
	  }
      }

    if (bit != 0)
      {
	number <<= (6-bit);
	printf("%c", number+63);
      }
    printf("\n");
  }

  int check()
  {
    int i,j,k,l;

    int * non_vis = new int [n];
    int * q = new int [n];

    for (i = 0 ; i < n ; i++)
      non_vis[i] = 1;

    int nr_comp = 0;

    for (l = 0 ; l < n ; l++)
      if (non_vis[l])
	{
	  non_vis[l] = 0;
	  q[0] = l;
	  j = 0;
	  k = 1;

	  while (k > j)
	    {
	      int cur = q[j];
	      j++;
	      
	      for (i = 0 ; i < n ; i++)
		if ( (g[cur][i]) && (non_vis[i]) )
		  {
		    q[k] = i;
		    k++;
		    non_vis[i] = 0;
		  }
	    }

	  if (k > 1)
	    nr_comp++;
	}
    
    delete [] non_vis;
    delete [] q;

    if ( nr_comp <= 1 )
      return 1;
    else
      return 0;
  }

};

int main(int argc, char * argv[])
{
  FILE * in = fopen(argv[1], "rt");

  char graph_text [100];
  int suf, nec;

  while (!feof(in))
    {
      fscanf(in, "%s\n", graph_text);
      graph g(graph_text);

      if (g.check()) 
	{
	  g.print_graph();
	}
    }

  return 0;
}

